package controlisolation.lifecyclefsm;

import java.util.logging.Level;
import java.util.logging.Logger;
import controlisolation.lifecyclefsm.stateexecutor.StateWork;

public abstract class LifeCycleFSMController {

    protected final static Logger _logger = Logger.getLogger(LifeCycleFSMController.class.getName());
    //protected boolean _running=false;
    protected LifeCycleFSM _lfsm;
    
    public static Logger getLogger() {
        return _logger;
    }

    /*
    public boolean isRunning() {
        return _running;
    }

    public void setRunning(boolean running) {
        this._running = running;
    }
    
    public void run(){ _running=true; }
    public void stop(){ _running=false; }*/
    
    /* Unified Error Control Method */
	protected void unifiedErrorControl(StateWork work){
		try{
		getLfsm().stop();
		} catch (Exception e){
		_logger.log(Level.SEVERE,"Exceptions got in unified Error Control Method."+e.toString());
                if (!work.getWorkExceptions().isEmpty())
                {
                    for (Exception ex:work.getWorkExceptions())
                        _logger.log(Level.SEVERE,ex.toString());
                }
		}
	}

    public LifeCycleFSM getLfsm() {
        return _lfsm;
    }

    public void setLfsm(LifeCycleFSM lfsm) {
        this._lfsm = lfsm;
    }
	
    public abstract void controlCycle() throws Exception;
}
